package hu.bme.mit.inf.socialnetwork.language.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import hu.bme.mit.inf.socialnetwork.language.services.SocialNetworkLanguageGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialNetworkLanguageParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'friend'", "'relative'", "'college'", "'social'", "'network'", "'{'", "'}'", "'community'", "'person'", "'communities'", "','", "'of'"
    };
    public static final int RULE_ID=4;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalSocialNetworkLanguageParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSocialNetworkLanguageParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSocialNetworkLanguageParser.tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g"; }


     
     	private SocialNetworkLanguageGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(SocialNetworkLanguageGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start "entryRuleSocialNetwork"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:60:1: entryRuleSocialNetwork : ruleSocialNetwork EOF ;
    public final void entryRuleSocialNetwork() throws RecognitionException {
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:61:1: ( ruleSocialNetwork EOF )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:62:1: ruleSocialNetwork EOF
            {
             before(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61);
            ruleSocialNetwork();

            state._fsp--;

             after(grammarAccess.getSocialNetworkRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSocialNetwork"


    // $ANTLR start "ruleSocialNetwork"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:69:1: ruleSocialNetwork : ( ( rule__SocialNetwork__Group__0 ) ) ;
    public final void ruleSocialNetwork() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:73:2: ( ( ( rule__SocialNetwork__Group__0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:74:1: ( ( rule__SocialNetwork__Group__0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:74:1: ( ( rule__SocialNetwork__Group__0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:75:1: ( rule__SocialNetwork__Group__0 )
            {
             before(grammarAccess.getSocialNetworkAccess().getGroup()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:76:1: ( rule__SocialNetwork__Group__0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:76:2: rule__SocialNetwork__Group__0
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94);
            rule__SocialNetwork__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSocialNetworkAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSocialNetwork"


    // $ANTLR start "entryRuleEntity"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:88:1: entryRuleEntity : ruleEntity EOF ;
    public final void entryRuleEntity() throws RecognitionException {
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:89:1: ( ruleEntity EOF )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:90:1: ruleEntity EOF
            {
             before(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_ruleEntity_in_entryRuleEntity121);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getEntityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleEntity128); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:97:1: ruleEntity : ( ( rule__Entity__Alternatives ) ) ;
    public final void ruleEntity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:101:2: ( ( ( rule__Entity__Alternatives ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:102:1: ( ( rule__Entity__Alternatives ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:102:1: ( ( rule__Entity__Alternatives ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:103:1: ( rule__Entity__Alternatives )
            {
             before(grammarAccess.getEntityAccess().getAlternatives()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:104:1: ( rule__Entity__Alternatives )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:104:2: rule__Entity__Alternatives
            {
            pushFollow(FOLLOW_rule__Entity__Alternatives_in_ruleEntity154);
            rule__Entity__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getEntityAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEntity"


    // $ANTLR start "entryRuleCommunity"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:116:1: entryRuleCommunity : ruleCommunity EOF ;
    public final void entryRuleCommunity() throws RecognitionException {
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:117:1: ( ruleCommunity EOF )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:118:1: ruleCommunity EOF
            {
             before(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity181);
            ruleCommunity();

            state._fsp--;

             after(grammarAccess.getCommunityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity188); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleCommunity"


    // $ANTLR start "ruleCommunity"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:125:1: ruleCommunity : ( ( rule__Community__Group__0 ) ) ;
    public final void ruleCommunity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:129:2: ( ( ( rule__Community__Group__0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:130:1: ( ( rule__Community__Group__0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:130:1: ( ( rule__Community__Group__0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:131:1: ( rule__Community__Group__0 )
            {
             before(grammarAccess.getCommunityAccess().getGroup()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:132:1: ( rule__Community__Group__0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:132:2: rule__Community__Group__0
            {
            pushFollow(FOLLOW_rule__Community__Group__0_in_ruleCommunity214);
            rule__Community__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getCommunityAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleCommunity"


    // $ANTLR start "entryRulePerson"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:144:1: entryRulePerson : rulePerson EOF ;
    public final void entryRulePerson() throws RecognitionException {
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:145:1: ( rulePerson EOF )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:146:1: rulePerson EOF
            {
             before(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson241);
            rulePerson();

            state._fsp--;

             after(grammarAccess.getPersonRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson248); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePerson"


    // $ANTLR start "rulePerson"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:153:1: rulePerson : ( ( rule__Person__Group__0 ) ) ;
    public final void rulePerson() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:157:2: ( ( ( rule__Person__Group__0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:158:1: ( ( rule__Person__Group__0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:158:1: ( ( rule__Person__Group__0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:159:1: ( rule__Person__Group__0 )
            {
             before(grammarAccess.getPersonAccess().getGroup()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:160:1: ( rule__Person__Group__0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:160:2: rule__Person__Group__0
            {
            pushFollow(FOLLOW_rule__Person__Group__0_in_rulePerson274);
            rule__Person__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePerson"


    // $ANTLR start "entryRuleAcquaintace"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:172:1: entryRuleAcquaintace : ruleAcquaintace EOF ;
    public final void entryRuleAcquaintace() throws RecognitionException {
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:173:1: ( ruleAcquaintace EOF )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:174:1: ruleAcquaintace EOF
            {
             before(grammarAccess.getAcquaintaceRule()); 
            pushFollow(FOLLOW_ruleAcquaintace_in_entryRuleAcquaintace301);
            ruleAcquaintace();

            state._fsp--;

             after(grammarAccess.getAcquaintaceRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAcquaintace308); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAcquaintace"


    // $ANTLR start "ruleAcquaintace"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:181:1: ruleAcquaintace : ( ( rule__Acquaintace__Group__0 ) ) ;
    public final void ruleAcquaintace() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:185:2: ( ( ( rule__Acquaintace__Group__0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:186:1: ( ( rule__Acquaintace__Group__0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:186:1: ( ( rule__Acquaintace__Group__0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:187:1: ( rule__Acquaintace__Group__0 )
            {
             before(grammarAccess.getAcquaintaceAccess().getGroup()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:188:1: ( rule__Acquaintace__Group__0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:188:2: rule__Acquaintace__Group__0
            {
            pushFollow(FOLLOW_rule__Acquaintace__Group__0_in_ruleAcquaintace334);
            rule__Acquaintace__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintaceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAcquaintace"


    // $ANTLR start "ruleAcqType"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:201:1: ruleAcqType : ( ( rule__AcqType__Alternatives ) ) ;
    public final void ruleAcqType() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:205:1: ( ( ( rule__AcqType__Alternatives ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:206:1: ( ( rule__AcqType__Alternatives ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:206:1: ( ( rule__AcqType__Alternatives ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:207:1: ( rule__AcqType__Alternatives )
            {
             before(grammarAccess.getAcqTypeAccess().getAlternatives()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:208:1: ( rule__AcqType__Alternatives )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:208:2: rule__AcqType__Alternatives
            {
            pushFollow(FOLLOW_rule__AcqType__Alternatives_in_ruleAcqType371);
            rule__AcqType__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getAcqTypeAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAcqType"


    // $ANTLR start "rule__Entity__Alternatives"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:219:1: rule__Entity__Alternatives : ( ( ruleCommunity ) | ( rulePerson ) );
    public final void rule__Entity__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:223:1: ( ( ruleCommunity ) | ( rulePerson ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==18) ) {
                alt1=1;
            }
            else if ( (LA1_0==19) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:224:1: ( ruleCommunity )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:224:1: ( ruleCommunity )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:225:1: ruleCommunity
                    {
                     before(grammarAccess.getEntityAccess().getCommunityParserRuleCall_0()); 
                    pushFollow(FOLLOW_ruleCommunity_in_rule__Entity__Alternatives406);
                    ruleCommunity();

                    state._fsp--;

                     after(grammarAccess.getEntityAccess().getCommunityParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:230:6: ( rulePerson )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:230:6: ( rulePerson )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:231:1: rulePerson
                    {
                     before(grammarAccess.getEntityAccess().getPersonParserRuleCall_1()); 
                    pushFollow(FOLLOW_rulePerson_in_rule__Entity__Alternatives423);
                    rulePerson();

                    state._fsp--;

                     after(grammarAccess.getEntityAccess().getPersonParserRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Alternatives"


    // $ANTLR start "rule__AcqType__Alternatives"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:241:1: rule__AcqType__Alternatives : ( ( ( 'friend' ) ) | ( ( 'relative' ) ) | ( ( 'college' ) ) );
    public final void rule__AcqType__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:245:1: ( ( ( 'friend' ) ) | ( ( 'relative' ) ) | ( ( 'college' ) ) )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 11:
                {
                alt2=1;
                }
                break;
            case 12:
                {
                alt2=2;
                }
                break;
            case 13:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:246:1: ( ( 'friend' ) )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:246:1: ( ( 'friend' ) )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:247:1: ( 'friend' )
                    {
                     before(grammarAccess.getAcqTypeAccess().getFriendEnumLiteralDeclaration_0()); 
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:248:1: ( 'friend' )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:248:3: 'friend'
                    {
                    match(input,11,FOLLOW_11_in_rule__AcqType__Alternatives456); 

                    }

                     after(grammarAccess.getAcqTypeAccess().getFriendEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:253:6: ( ( 'relative' ) )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:253:6: ( ( 'relative' ) )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:254:1: ( 'relative' )
                    {
                     before(grammarAccess.getAcqTypeAccess().getRelativeEnumLiteralDeclaration_1()); 
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:255:1: ( 'relative' )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:255:3: 'relative'
                    {
                    match(input,12,FOLLOW_12_in_rule__AcqType__Alternatives477); 

                    }

                     after(grammarAccess.getAcqTypeAccess().getRelativeEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;
                case 3 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:260:6: ( ( 'college' ) )
                    {
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:260:6: ( ( 'college' ) )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:261:1: ( 'college' )
                    {
                     before(grammarAccess.getAcqTypeAccess().getCollegeEnumLiteralDeclaration_2()); 
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:262:1: ( 'college' )
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:262:3: 'college'
                    {
                    match(input,13,FOLLOW_13_in_rule__AcqType__Alternatives498); 

                    }

                     after(grammarAccess.getAcqTypeAccess().getCollegeEnumLiteralDeclaration_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AcqType__Alternatives"


    // $ANTLR start "rule__SocialNetwork__Group__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:274:1: rule__SocialNetwork__Group__0 : rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 ;
    public final void rule__SocialNetwork__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:278:1: ( rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:279:2: rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0531);
            rule__SocialNetwork__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0534);
            rule__SocialNetwork__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__0"


    // $ANTLR start "rule__SocialNetwork__Group__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:286:1: rule__SocialNetwork__Group__0__Impl : ( 'social' ) ;
    public final void rule__SocialNetwork__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:290:1: ( ( 'social' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:291:1: ( 'social' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:291:1: ( 'social' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:292:1: 'social'
            {
             before(grammarAccess.getSocialNetworkAccess().getSocialKeyword_0()); 
            match(input,14,FOLLOW_14_in_rule__SocialNetwork__Group__0__Impl562); 
             after(grammarAccess.getSocialNetworkAccess().getSocialKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__0__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:305:1: rule__SocialNetwork__Group__1 : rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 ;
    public final void rule__SocialNetwork__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:309:1: ( rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:310:2: rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1593);
            rule__SocialNetwork__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1596);
            rule__SocialNetwork__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__1"


    // $ANTLR start "rule__SocialNetwork__Group__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:317:1: rule__SocialNetwork__Group__1__Impl : ( 'network' ) ;
    public final void rule__SocialNetwork__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:321:1: ( ( 'network' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:322:1: ( 'network' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:322:1: ( 'network' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:323:1: 'network'
            {
             before(grammarAccess.getSocialNetworkAccess().getNetworkKeyword_1()); 
            match(input,15,FOLLOW_15_in_rule__SocialNetwork__Group__1__Impl624); 
             after(grammarAccess.getSocialNetworkAccess().getNetworkKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__1__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:336:1: rule__SocialNetwork__Group__2 : rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 ;
    public final void rule__SocialNetwork__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:340:1: ( rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:341:2: rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2655);
            rule__SocialNetwork__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2658);
            rule__SocialNetwork__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__2"


    // $ANTLR start "rule__SocialNetwork__Group__2__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:348:1: rule__SocialNetwork__Group__2__Impl : ( () ) ;
    public final void rule__SocialNetwork__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:352:1: ( ( () ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:353:1: ( () )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:353:1: ( () )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:354:1: ()
            {
             before(grammarAccess.getSocialNetworkAccess().getSocialNetworkAction_2()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:355:1: ()
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:357:1: 
            {
            }

             after(grammarAccess.getSocialNetworkAccess().getSocialNetworkAction_2()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__2__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__3"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:367:1: rule__SocialNetwork__Group__3 : rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4 ;
    public final void rule__SocialNetwork__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:371:1: ( rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:372:2: rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3716);
            rule__SocialNetwork__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__4_in_rule__SocialNetwork__Group__3719);
            rule__SocialNetwork__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__3"


    // $ANTLR start "rule__SocialNetwork__Group__3__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:379:1: rule__SocialNetwork__Group__3__Impl : ( '{' ) ;
    public final void rule__SocialNetwork__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:383:1: ( ( '{' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:384:1: ( '{' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:384:1: ( '{' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:385:1: '{'
            {
             before(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,16,FOLLOW_16_in_rule__SocialNetwork__Group__3__Impl747); 
             after(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__3__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__4"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:398:1: rule__SocialNetwork__Group__4 : rule__SocialNetwork__Group__4__Impl rule__SocialNetwork__Group__5 ;
    public final void rule__SocialNetwork__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:402:1: ( rule__SocialNetwork__Group__4__Impl rule__SocialNetwork__Group__5 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:403:2: rule__SocialNetwork__Group__4__Impl rule__SocialNetwork__Group__5
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__4__Impl_in_rule__SocialNetwork__Group__4778);
            rule__SocialNetwork__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__5_in_rule__SocialNetwork__Group__4781);
            rule__SocialNetwork__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__4"


    // $ANTLR start "rule__SocialNetwork__Group__4__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:410:1: rule__SocialNetwork__Group__4__Impl : ( ( rule__SocialNetwork__EntitiesAssignment_4 )* ) ;
    public final void rule__SocialNetwork__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:414:1: ( ( ( rule__SocialNetwork__EntitiesAssignment_4 )* ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:415:1: ( ( rule__SocialNetwork__EntitiesAssignment_4 )* )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:415:1: ( ( rule__SocialNetwork__EntitiesAssignment_4 )* )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:416:1: ( rule__SocialNetwork__EntitiesAssignment_4 )*
            {
             before(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_4()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:417:1: ( rule__SocialNetwork__EntitiesAssignment_4 )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=18 && LA3_0<=19)) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:417:2: rule__SocialNetwork__EntitiesAssignment_4
            	    {
            	    pushFollow(FOLLOW_rule__SocialNetwork__EntitiesAssignment_4_in_rule__SocialNetwork__Group__4__Impl808);
            	    rule__SocialNetwork__EntitiesAssignment_4();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

             after(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__4__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__5"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:427:1: rule__SocialNetwork__Group__5 : rule__SocialNetwork__Group__5__Impl ;
    public final void rule__SocialNetwork__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:431:1: ( rule__SocialNetwork__Group__5__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:432:2: rule__SocialNetwork__Group__5__Impl
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__5__Impl_in_rule__SocialNetwork__Group__5839);
            rule__SocialNetwork__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__5"


    // $ANTLR start "rule__SocialNetwork__Group__5__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:438:1: rule__SocialNetwork__Group__5__Impl : ( '}' ) ;
    public final void rule__SocialNetwork__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:442:1: ( ( '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:443:1: ( '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:443:1: ( '}' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:444:1: '}'
            {
             before(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_5()); 
            match(input,17,FOLLOW_17_in_rule__SocialNetwork__Group__5__Impl867); 
             after(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__5__Impl"


    // $ANTLR start "rule__Community__Group__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:469:1: rule__Community__Group__0 : rule__Community__Group__0__Impl rule__Community__Group__1 ;
    public final void rule__Community__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:473:1: ( rule__Community__Group__0__Impl rule__Community__Group__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:474:2: rule__Community__Group__0__Impl rule__Community__Group__1
            {
            pushFollow(FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__0910);
            rule__Community__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group__1_in_rule__Community__Group__0913);
            rule__Community__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__0"


    // $ANTLR start "rule__Community__Group__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:481:1: rule__Community__Group__0__Impl : ( 'community' ) ;
    public final void rule__Community__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:485:1: ( ( 'community' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:486:1: ( 'community' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:486:1: ( 'community' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:487:1: 'community'
            {
             before(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 
            match(input,18,FOLLOW_18_in_rule__Community__Group__0__Impl941); 
             after(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__0__Impl"


    // $ANTLR start "rule__Community__Group__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:500:1: rule__Community__Group__1 : rule__Community__Group__1__Impl rule__Community__Group__2 ;
    public final void rule__Community__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:504:1: ( rule__Community__Group__1__Impl rule__Community__Group__2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:505:2: rule__Community__Group__1__Impl rule__Community__Group__2
            {
            pushFollow(FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__1972);
            rule__Community__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group__2_in_rule__Community__Group__1975);
            rule__Community__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__1"


    // $ANTLR start "rule__Community__Group__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:512:1: rule__Community__Group__1__Impl : ( ( rule__Community__NameAssignment_1 ) ) ;
    public final void rule__Community__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:516:1: ( ( ( rule__Community__NameAssignment_1 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:517:1: ( ( rule__Community__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:517:1: ( ( rule__Community__NameAssignment_1 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:518:1: ( rule__Community__NameAssignment_1 )
            {
             before(grammarAccess.getCommunityAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:519:1: ( rule__Community__NameAssignment_1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:519:2: rule__Community__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1002);
            rule__Community__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getCommunityAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__1__Impl"


    // $ANTLR start "rule__Community__Group__2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:529:1: rule__Community__Group__2 : rule__Community__Group__2__Impl ;
    public final void rule__Community__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:533:1: ( rule__Community__Group__2__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:534:2: rule__Community__Group__2__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21032);
            rule__Community__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__2"


    // $ANTLR start "rule__Community__Group__2__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:540:1: rule__Community__Group__2__Impl : ( ( rule__Community__Group_2__0 )? ) ;
    public final void rule__Community__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:544:1: ( ( ( rule__Community__Group_2__0 )? ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:545:1: ( ( rule__Community__Group_2__0 )? )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:545:1: ( ( rule__Community__Group_2__0 )? )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:546:1: ( rule__Community__Group_2__0 )?
            {
             before(grammarAccess.getCommunityAccess().getGroup_2()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:547:1: ( rule__Community__Group_2__0 )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==16) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:547:2: rule__Community__Group_2__0
                    {
                    pushFollow(FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1059);
                    rule__Community__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getCommunityAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__2__Impl"


    // $ANTLR start "rule__Community__Group_2__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:563:1: rule__Community__Group_2__0 : rule__Community__Group_2__0__Impl rule__Community__Group_2__1 ;
    public final void rule__Community__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:567:1: ( rule__Community__Group_2__0__Impl rule__Community__Group_2__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:568:2: rule__Community__Group_2__0__Impl rule__Community__Group_2__1
            {
            pushFollow(FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__01096);
            rule__Community__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__01099);
            rule__Community__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__0"


    // $ANTLR start "rule__Community__Group_2__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:575:1: rule__Community__Group_2__0__Impl : ( '{' ) ;
    public final void rule__Community__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:579:1: ( ( '{' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:580:1: ( '{' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:580:1: ( '{' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:581:1: '{'
            {
             before(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 
            match(input,16,FOLLOW_16_in_rule__Community__Group_2__0__Impl1127); 
             after(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__0__Impl"


    // $ANTLR start "rule__Community__Group_2__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:594:1: rule__Community__Group_2__1 : rule__Community__Group_2__1__Impl rule__Community__Group_2__2 ;
    public final void rule__Community__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:598:1: ( rule__Community__Group_2__1__Impl rule__Community__Group_2__2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:599:2: rule__Community__Group_2__1__Impl rule__Community__Group_2__2
            {
            pushFollow(FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__11158);
            rule__Community__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__11161);
            rule__Community__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__1"


    // $ANTLR start "rule__Community__Group_2__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:606:1: rule__Community__Group_2__1__Impl : ( ( rule__Community__SubcommunitiesAssignment_2_1 )* ) ;
    public final void rule__Community__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:610:1: ( ( ( rule__Community__SubcommunitiesAssignment_2_1 )* ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:611:1: ( ( rule__Community__SubcommunitiesAssignment_2_1 )* )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:611:1: ( ( rule__Community__SubcommunitiesAssignment_2_1 )* )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:612:1: ( rule__Community__SubcommunitiesAssignment_2_1 )*
            {
             before(grammarAccess.getCommunityAccess().getSubcommunitiesAssignment_2_1()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:613:1: ( rule__Community__SubcommunitiesAssignment_2_1 )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==18) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:613:2: rule__Community__SubcommunitiesAssignment_2_1
            	    {
            	    pushFollow(FOLLOW_rule__Community__SubcommunitiesAssignment_2_1_in_rule__Community__Group_2__1__Impl1188);
            	    rule__Community__SubcommunitiesAssignment_2_1();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

             after(grammarAccess.getCommunityAccess().getSubcommunitiesAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__1__Impl"


    // $ANTLR start "rule__Community__Group_2__2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:623:1: rule__Community__Group_2__2 : rule__Community__Group_2__2__Impl ;
    public final void rule__Community__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:627:1: ( rule__Community__Group_2__2__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:628:2: rule__Community__Group_2__2__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__21219);
            rule__Community__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__2"


    // $ANTLR start "rule__Community__Group_2__2__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:634:1: rule__Community__Group_2__2__Impl : ( '}' ) ;
    public final void rule__Community__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:638:1: ( ( '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:639:1: ( '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:639:1: ( '}' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:640:1: '}'
            {
             before(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2()); 
            match(input,17,FOLLOW_17_in_rule__Community__Group_2__2__Impl1247); 
             after(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__2__Impl"


    // $ANTLR start "rule__Person__Group__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:659:1: rule__Person__Group__0 : rule__Person__Group__0__Impl rule__Person__Group__1 ;
    public final void rule__Person__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:663:1: ( rule__Person__Group__0__Impl rule__Person__Group__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:664:2: rule__Person__Group__0__Impl rule__Person__Group__1
            {
            pushFollow(FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__01284);
            rule__Person__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__1_in_rule__Person__Group__01287);
            rule__Person__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__0"


    // $ANTLR start "rule__Person__Group__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:671:1: rule__Person__Group__0__Impl : ( 'person' ) ;
    public final void rule__Person__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:675:1: ( ( 'person' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:676:1: ( 'person' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:676:1: ( 'person' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:677:1: 'person'
            {
             before(grammarAccess.getPersonAccess().getPersonKeyword_0()); 
            match(input,19,FOLLOW_19_in_rule__Person__Group__0__Impl1315); 
             after(grammarAccess.getPersonAccess().getPersonKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__0__Impl"


    // $ANTLR start "rule__Person__Group__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:690:1: rule__Person__Group__1 : rule__Person__Group__1__Impl rule__Person__Group__2 ;
    public final void rule__Person__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:694:1: ( rule__Person__Group__1__Impl rule__Person__Group__2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:695:2: rule__Person__Group__1__Impl rule__Person__Group__2
            {
            pushFollow(FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__11346);
            rule__Person__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__2_in_rule__Person__Group__11349);
            rule__Person__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__1"


    // $ANTLR start "rule__Person__Group__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:702:1: rule__Person__Group__1__Impl : ( ( rule__Person__NameAssignment_1 ) ) ;
    public final void rule__Person__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:706:1: ( ( ( rule__Person__NameAssignment_1 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:707:1: ( ( rule__Person__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:707:1: ( ( rule__Person__NameAssignment_1 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:708:1: ( rule__Person__NameAssignment_1 )
            {
             before(grammarAccess.getPersonAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:709:1: ( rule__Person__NameAssignment_1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:709:2: rule__Person__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1376);
            rule__Person__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__1__Impl"


    // $ANTLR start "rule__Person__Group__2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:719:1: rule__Person__Group__2 : rule__Person__Group__2__Impl rule__Person__Group__3 ;
    public final void rule__Person__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:723:1: ( rule__Person__Group__2__Impl rule__Person__Group__3 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:724:2: rule__Person__Group__2__Impl rule__Person__Group__3
            {
            pushFollow(FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21406);
            rule__Person__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21409);
            rule__Person__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__2"


    // $ANTLR start "rule__Person__Group__2__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:731:1: rule__Person__Group__2__Impl : ( '{' ) ;
    public final void rule__Person__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:735:1: ( ( '{' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:736:1: ( '{' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:736:1: ( '{' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:737:1: '{'
            {
             before(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,16,FOLLOW_16_in_rule__Person__Group__2__Impl1437); 
             after(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__2__Impl"


    // $ANTLR start "rule__Person__Group__3"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:750:1: rule__Person__Group__3 : rule__Person__Group__3__Impl rule__Person__Group__4 ;
    public final void rule__Person__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:754:1: ( rule__Person__Group__3__Impl rule__Person__Group__4 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:755:2: rule__Person__Group__3__Impl rule__Person__Group__4
            {
            pushFollow(FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31468);
            rule__Person__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31471);
            rule__Person__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__3"


    // $ANTLR start "rule__Person__Group__3__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:762:1: rule__Person__Group__3__Impl : ( 'communities' ) ;
    public final void rule__Person__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:766:1: ( ( 'communities' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:767:1: ( 'communities' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:767:1: ( 'communities' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:768:1: 'communities'
            {
             before(grammarAccess.getPersonAccess().getCommunitiesKeyword_3()); 
            match(input,20,FOLLOW_20_in_rule__Person__Group__3__Impl1499); 
             after(grammarAccess.getPersonAccess().getCommunitiesKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__3__Impl"


    // $ANTLR start "rule__Person__Group__4"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:781:1: rule__Person__Group__4 : rule__Person__Group__4__Impl rule__Person__Group__5 ;
    public final void rule__Person__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:785:1: ( rule__Person__Group__4__Impl rule__Person__Group__5 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:786:2: rule__Person__Group__4__Impl rule__Person__Group__5
            {
            pushFollow(FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41530);
            rule__Person__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41533);
            rule__Person__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__4"


    // $ANTLR start "rule__Person__Group__4__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:793:1: rule__Person__Group__4__Impl : ( '{' ) ;
    public final void rule__Person__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:797:1: ( ( '{' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:798:1: ( '{' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:798:1: ( '{' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:799:1: '{'
            {
             before(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_4()); 
            match(input,16,FOLLOW_16_in_rule__Person__Group__4__Impl1561); 
             after(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__4__Impl"


    // $ANTLR start "rule__Person__Group__5"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:812:1: rule__Person__Group__5 : rule__Person__Group__5__Impl rule__Person__Group__6 ;
    public final void rule__Person__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:816:1: ( rule__Person__Group__5__Impl rule__Person__Group__6 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:817:2: rule__Person__Group__5__Impl rule__Person__Group__6
            {
            pushFollow(FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51592);
            rule__Person__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__6_in_rule__Person__Group__51595);
            rule__Person__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__5"


    // $ANTLR start "rule__Person__Group__5__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:824:1: rule__Person__Group__5__Impl : ( ( rule__Person__Group_5__0 )? ) ;
    public final void rule__Person__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:828:1: ( ( ( rule__Person__Group_5__0 )? ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:829:1: ( ( rule__Person__Group_5__0 )? )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:829:1: ( ( rule__Person__Group_5__0 )? )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:830:1: ( rule__Person__Group_5__0 )?
            {
             before(grammarAccess.getPersonAccess().getGroup_5()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:831:1: ( rule__Person__Group_5__0 )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==RULE_ID) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:831:2: rule__Person__Group_5__0
                    {
                    pushFollow(FOLLOW_rule__Person__Group_5__0_in_rule__Person__Group__5__Impl1622);
                    rule__Person__Group_5__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPersonAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__5__Impl"


    // $ANTLR start "rule__Person__Group__6"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:841:1: rule__Person__Group__6 : rule__Person__Group__6__Impl rule__Person__Group__7 ;
    public final void rule__Person__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:845:1: ( rule__Person__Group__6__Impl rule__Person__Group__7 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:846:2: rule__Person__Group__6__Impl rule__Person__Group__7
            {
            pushFollow(FOLLOW_rule__Person__Group__6__Impl_in_rule__Person__Group__61653);
            rule__Person__Group__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__7_in_rule__Person__Group__61656);
            rule__Person__Group__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__6"


    // $ANTLR start "rule__Person__Group__6__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:853:1: rule__Person__Group__6__Impl : ( '}' ) ;
    public final void rule__Person__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:857:1: ( ( '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:858:1: ( '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:858:1: ( '}' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:859:1: '}'
            {
             before(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_6()); 
            match(input,17,FOLLOW_17_in_rule__Person__Group__6__Impl1684); 
             after(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__6__Impl"


    // $ANTLR start "rule__Person__Group__7"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:872:1: rule__Person__Group__7 : rule__Person__Group__7__Impl rule__Person__Group__8 ;
    public final void rule__Person__Group__7() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:876:1: ( rule__Person__Group__7__Impl rule__Person__Group__8 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:877:2: rule__Person__Group__7__Impl rule__Person__Group__8
            {
            pushFollow(FOLLOW_rule__Person__Group__7__Impl_in_rule__Person__Group__71715);
            rule__Person__Group__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__8_in_rule__Person__Group__71718);
            rule__Person__Group__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__7"


    // $ANTLR start "rule__Person__Group__7__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:884:1: rule__Person__Group__7__Impl : ( ( rule__Person__AcquaintacesAssignment_7 )* ) ;
    public final void rule__Person__Group__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:888:1: ( ( ( rule__Person__AcquaintacesAssignment_7 )* ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:889:1: ( ( rule__Person__AcquaintacesAssignment_7 )* )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:889:1: ( ( rule__Person__AcquaintacesAssignment_7 )* )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:890:1: ( rule__Person__AcquaintacesAssignment_7 )*
            {
             before(grammarAccess.getPersonAccess().getAcquaintacesAssignment_7()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:891:1: ( rule__Person__AcquaintacesAssignment_7 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>=11 && LA7_0<=13)) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:891:2: rule__Person__AcquaintacesAssignment_7
            	    {
            	    pushFollow(FOLLOW_rule__Person__AcquaintacesAssignment_7_in_rule__Person__Group__7__Impl1745);
            	    rule__Person__AcquaintacesAssignment_7();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getPersonAccess().getAcquaintacesAssignment_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__7__Impl"


    // $ANTLR start "rule__Person__Group__8"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:901:1: rule__Person__Group__8 : rule__Person__Group__8__Impl ;
    public final void rule__Person__Group__8() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:905:1: ( rule__Person__Group__8__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:906:2: rule__Person__Group__8__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group__8__Impl_in_rule__Person__Group__81776);
            rule__Person__Group__8__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__8"


    // $ANTLR start "rule__Person__Group__8__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:912:1: rule__Person__Group__8__Impl : ( '}' ) ;
    public final void rule__Person__Group__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:916:1: ( ( '}' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:917:1: ( '}' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:917:1: ( '}' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:918:1: '}'
            {
             before(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_8()); 
            match(input,17,FOLLOW_17_in_rule__Person__Group__8__Impl1804); 
             after(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__8__Impl"


    // $ANTLR start "rule__Person__Group_5__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:949:1: rule__Person__Group_5__0 : rule__Person__Group_5__0__Impl rule__Person__Group_5__1 ;
    public final void rule__Person__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:953:1: ( rule__Person__Group_5__0__Impl rule__Person__Group_5__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:954:2: rule__Person__Group_5__0__Impl rule__Person__Group_5__1
            {
            pushFollow(FOLLOW_rule__Person__Group_5__0__Impl_in_rule__Person__Group_5__01853);
            rule__Person__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group_5__1_in_rule__Person__Group_5__01856);
            rule__Person__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5__0"


    // $ANTLR start "rule__Person__Group_5__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:961:1: rule__Person__Group_5__0__Impl : ( ( rule__Person__CommunityAssignment_5_0 ) ) ;
    public final void rule__Person__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:965:1: ( ( ( rule__Person__CommunityAssignment_5_0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:966:1: ( ( rule__Person__CommunityAssignment_5_0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:966:1: ( ( rule__Person__CommunityAssignment_5_0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:967:1: ( rule__Person__CommunityAssignment_5_0 )
            {
             before(grammarAccess.getPersonAccess().getCommunityAssignment_5_0()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:968:1: ( rule__Person__CommunityAssignment_5_0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:968:2: rule__Person__CommunityAssignment_5_0
            {
            pushFollow(FOLLOW_rule__Person__CommunityAssignment_5_0_in_rule__Person__Group_5__0__Impl1883);
            rule__Person__CommunityAssignment_5_0();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getCommunityAssignment_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5__0__Impl"


    // $ANTLR start "rule__Person__Group_5__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:978:1: rule__Person__Group_5__1 : rule__Person__Group_5__1__Impl ;
    public final void rule__Person__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:982:1: ( rule__Person__Group_5__1__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:983:2: rule__Person__Group_5__1__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_5__1__Impl_in_rule__Person__Group_5__11913);
            rule__Person__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5__1"


    // $ANTLR start "rule__Person__Group_5__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:989:1: rule__Person__Group_5__1__Impl : ( ( rule__Person__Group_5_1__0 )* ) ;
    public final void rule__Person__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:993:1: ( ( ( rule__Person__Group_5_1__0 )* ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:994:1: ( ( rule__Person__Group_5_1__0 )* )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:994:1: ( ( rule__Person__Group_5_1__0 )* )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:995:1: ( rule__Person__Group_5_1__0 )*
            {
             before(grammarAccess.getPersonAccess().getGroup_5_1()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:996:1: ( rule__Person__Group_5_1__0 )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==21) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:996:2: rule__Person__Group_5_1__0
            	    {
            	    pushFollow(FOLLOW_rule__Person__Group_5_1__0_in_rule__Person__Group_5__1__Impl1940);
            	    rule__Person__Group_5_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

             after(grammarAccess.getPersonAccess().getGroup_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5__1__Impl"


    // $ANTLR start "rule__Person__Group_5_1__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1010:1: rule__Person__Group_5_1__0 : rule__Person__Group_5_1__0__Impl rule__Person__Group_5_1__1 ;
    public final void rule__Person__Group_5_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1014:1: ( rule__Person__Group_5_1__0__Impl rule__Person__Group_5_1__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1015:2: rule__Person__Group_5_1__0__Impl rule__Person__Group_5_1__1
            {
            pushFollow(FOLLOW_rule__Person__Group_5_1__0__Impl_in_rule__Person__Group_5_1__01975);
            rule__Person__Group_5_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group_5_1__1_in_rule__Person__Group_5_1__01978);
            rule__Person__Group_5_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5_1__0"


    // $ANTLR start "rule__Person__Group_5_1__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1022:1: rule__Person__Group_5_1__0__Impl : ( ',' ) ;
    public final void rule__Person__Group_5_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1026:1: ( ( ',' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1027:1: ( ',' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1027:1: ( ',' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1028:1: ','
            {
             before(grammarAccess.getPersonAccess().getCommaKeyword_5_1_0()); 
            match(input,21,FOLLOW_21_in_rule__Person__Group_5_1__0__Impl2006); 
             after(grammarAccess.getPersonAccess().getCommaKeyword_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5_1__0__Impl"


    // $ANTLR start "rule__Person__Group_5_1__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1041:1: rule__Person__Group_5_1__1 : rule__Person__Group_5_1__1__Impl ;
    public final void rule__Person__Group_5_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1045:1: ( rule__Person__Group_5_1__1__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1046:2: rule__Person__Group_5_1__1__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_5_1__1__Impl_in_rule__Person__Group_5_1__12037);
            rule__Person__Group_5_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5_1__1"


    // $ANTLR start "rule__Person__Group_5_1__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1052:1: rule__Person__Group_5_1__1__Impl : ( ( rule__Person__CommunityAssignment_5_1_1 ) ) ;
    public final void rule__Person__Group_5_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1056:1: ( ( ( rule__Person__CommunityAssignment_5_1_1 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1057:1: ( ( rule__Person__CommunityAssignment_5_1_1 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1057:1: ( ( rule__Person__CommunityAssignment_5_1_1 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1058:1: ( rule__Person__CommunityAssignment_5_1_1 )
            {
             before(grammarAccess.getPersonAccess().getCommunityAssignment_5_1_1()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1059:1: ( rule__Person__CommunityAssignment_5_1_1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1059:2: rule__Person__CommunityAssignment_5_1_1
            {
            pushFollow(FOLLOW_rule__Person__CommunityAssignment_5_1_1_in_rule__Person__Group_5_1__1__Impl2064);
            rule__Person__CommunityAssignment_5_1_1();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getCommunityAssignment_5_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_5_1__1__Impl"


    // $ANTLR start "rule__Acquaintace__Group__0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1073:1: rule__Acquaintace__Group__0 : rule__Acquaintace__Group__0__Impl rule__Acquaintace__Group__1 ;
    public final void rule__Acquaintace__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1077:1: ( rule__Acquaintace__Group__0__Impl rule__Acquaintace__Group__1 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1078:2: rule__Acquaintace__Group__0__Impl rule__Acquaintace__Group__1
            {
            pushFollow(FOLLOW_rule__Acquaintace__Group__0__Impl_in_rule__Acquaintace__Group__02098);
            rule__Acquaintace__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintace__Group__1_in_rule__Acquaintace__Group__02101);
            rule__Acquaintace__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__0"


    // $ANTLR start "rule__Acquaintace__Group__0__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1085:1: rule__Acquaintace__Group__0__Impl : ( ( rule__Acquaintace__TypeAssignment_0 ) ) ;
    public final void rule__Acquaintace__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1089:1: ( ( ( rule__Acquaintace__TypeAssignment_0 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1090:1: ( ( rule__Acquaintace__TypeAssignment_0 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1090:1: ( ( rule__Acquaintace__TypeAssignment_0 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1091:1: ( rule__Acquaintace__TypeAssignment_0 )
            {
             before(grammarAccess.getAcquaintaceAccess().getTypeAssignment_0()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1092:1: ( rule__Acquaintace__TypeAssignment_0 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1092:2: rule__Acquaintace__TypeAssignment_0
            {
            pushFollow(FOLLOW_rule__Acquaintace__TypeAssignment_0_in_rule__Acquaintace__Group__0__Impl2128);
            rule__Acquaintace__TypeAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintaceAccess().getTypeAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__0__Impl"


    // $ANTLR start "rule__Acquaintace__Group__1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1102:1: rule__Acquaintace__Group__1 : rule__Acquaintace__Group__1__Impl rule__Acquaintace__Group__2 ;
    public final void rule__Acquaintace__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1106:1: ( rule__Acquaintace__Group__1__Impl rule__Acquaintace__Group__2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1107:2: rule__Acquaintace__Group__1__Impl rule__Acquaintace__Group__2
            {
            pushFollow(FOLLOW_rule__Acquaintace__Group__1__Impl_in_rule__Acquaintace__Group__12158);
            rule__Acquaintace__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintace__Group__2_in_rule__Acquaintace__Group__12161);
            rule__Acquaintace__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__1"


    // $ANTLR start "rule__Acquaintace__Group__1__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1114:1: rule__Acquaintace__Group__1__Impl : ( 'of' ) ;
    public final void rule__Acquaintace__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1118:1: ( ( 'of' ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1119:1: ( 'of' )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1119:1: ( 'of' )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1120:1: 'of'
            {
             before(grammarAccess.getAcquaintaceAccess().getOfKeyword_1()); 
            match(input,22,FOLLOW_22_in_rule__Acquaintace__Group__1__Impl2189); 
             after(grammarAccess.getAcquaintaceAccess().getOfKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__1__Impl"


    // $ANTLR start "rule__Acquaintace__Group__2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1133:1: rule__Acquaintace__Group__2 : rule__Acquaintace__Group__2__Impl ;
    public final void rule__Acquaintace__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1137:1: ( rule__Acquaintace__Group__2__Impl )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1138:2: rule__Acquaintace__Group__2__Impl
            {
            pushFollow(FOLLOW_rule__Acquaintace__Group__2__Impl_in_rule__Acquaintace__Group__22220);
            rule__Acquaintace__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__2"


    // $ANTLR start "rule__Acquaintace__Group__2__Impl"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1144:1: rule__Acquaintace__Group__2__Impl : ( ( rule__Acquaintace__TargetAssignment_2 ) ) ;
    public final void rule__Acquaintace__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1148:1: ( ( ( rule__Acquaintace__TargetAssignment_2 ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1149:1: ( ( rule__Acquaintace__TargetAssignment_2 ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1149:1: ( ( rule__Acquaintace__TargetAssignment_2 ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1150:1: ( rule__Acquaintace__TargetAssignment_2 )
            {
             before(grammarAccess.getAcquaintaceAccess().getTargetAssignment_2()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1151:1: ( rule__Acquaintace__TargetAssignment_2 )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1151:2: rule__Acquaintace__TargetAssignment_2
            {
            pushFollow(FOLLOW_rule__Acquaintace__TargetAssignment_2_in_rule__Acquaintace__Group__2__Impl2247);
            rule__Acquaintace__TargetAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintaceAccess().getTargetAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__Group__2__Impl"


    // $ANTLR start "rule__SocialNetwork__EntitiesAssignment_4"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1168:1: rule__SocialNetwork__EntitiesAssignment_4 : ( ruleEntity ) ;
    public final void rule__SocialNetwork__EntitiesAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1172:1: ( ( ruleEntity ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1173:1: ( ruleEntity )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1173:1: ( ruleEntity )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1174:1: ruleEntity
            {
             before(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_4_0()); 
            pushFollow(FOLLOW_ruleEntity_in_rule__SocialNetwork__EntitiesAssignment_42288);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__EntitiesAssignment_4"


    // $ANTLR start "rule__Community__NameAssignment_1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1183:1: rule__Community__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Community__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1187:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1188:1: ( RULE_ID )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1188:1: ( RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1189:1: RULE_ID
            {
             before(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12319); 
             after(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__NameAssignment_1"


    // $ANTLR start "rule__Community__SubcommunitiesAssignment_2_1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1198:1: rule__Community__SubcommunitiesAssignment_2_1 : ( ruleCommunity ) ;
    public final void rule__Community__SubcommunitiesAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1202:1: ( ( ruleCommunity ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1203:1: ( ruleCommunity )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1203:1: ( ruleCommunity )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1204:1: ruleCommunity
            {
             before(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_ruleCommunity_in_rule__Community__SubcommunitiesAssignment_2_12350);
            ruleCommunity();

            state._fsp--;

             after(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__SubcommunitiesAssignment_2_1"


    // $ANTLR start "rule__Person__NameAssignment_1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1213:1: rule__Person__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Person__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1217:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1218:1: ( RULE_ID )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1218:1: ( RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1219:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12381); 
             after(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__NameAssignment_1"


    // $ANTLR start "rule__Person__CommunityAssignment_5_0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1228:1: rule__Person__CommunityAssignment_5_0 : ( ( RULE_ID ) ) ;
    public final void rule__Person__CommunityAssignment_5_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1232:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1233:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1233:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1234:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_0_0()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1235:1: ( RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1236:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getCommunityCommunityIDTerminalRuleCall_5_0_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__CommunityAssignment_5_02416); 
             after(grammarAccess.getPersonAccess().getCommunityCommunityIDTerminalRuleCall_5_0_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__CommunityAssignment_5_0"


    // $ANTLR start "rule__Person__CommunityAssignment_5_1_1"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1247:1: rule__Person__CommunityAssignment_5_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__Person__CommunityAssignment_5_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1251:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1252:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1252:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1253:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_1_1_0()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1254:1: ( RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1255:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getCommunityCommunityIDTerminalRuleCall_5_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__CommunityAssignment_5_1_12455); 
             after(grammarAccess.getPersonAccess().getCommunityCommunityIDTerminalRuleCall_5_1_1_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getCommunityCommunityCrossReference_5_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__CommunityAssignment_5_1_1"


    // $ANTLR start "rule__Person__AcquaintacesAssignment_7"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1266:1: rule__Person__AcquaintacesAssignment_7 : ( ruleAcquaintace ) ;
    public final void rule__Person__AcquaintacesAssignment_7() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1270:1: ( ( ruleAcquaintace ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1271:1: ( ruleAcquaintace )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1271:1: ( ruleAcquaintace )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1272:1: ruleAcquaintace
            {
             before(grammarAccess.getPersonAccess().getAcquaintacesAcquaintaceParserRuleCall_7_0()); 
            pushFollow(FOLLOW_ruleAcquaintace_in_rule__Person__AcquaintacesAssignment_72490);
            ruleAcquaintace();

            state._fsp--;

             after(grammarAccess.getPersonAccess().getAcquaintacesAcquaintaceParserRuleCall_7_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__AcquaintacesAssignment_7"


    // $ANTLR start "rule__Acquaintace__TypeAssignment_0"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1281:1: rule__Acquaintace__TypeAssignment_0 : ( ruleAcqType ) ;
    public final void rule__Acquaintace__TypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1285:1: ( ( ruleAcqType ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1286:1: ( ruleAcqType )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1286:1: ( ruleAcqType )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1287:1: ruleAcqType
            {
             before(grammarAccess.getAcquaintaceAccess().getTypeAcqTypeEnumRuleCall_0_0()); 
            pushFollow(FOLLOW_ruleAcqType_in_rule__Acquaintace__TypeAssignment_02521);
            ruleAcqType();

            state._fsp--;

             after(grammarAccess.getAcquaintaceAccess().getTypeAcqTypeEnumRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__TypeAssignment_0"


    // $ANTLR start "rule__Acquaintace__TargetAssignment_2"
    // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1296:1: rule__Acquaintace__TargetAssignment_2 : ( ( RULE_ID ) ) ;
    public final void rule__Acquaintace__TargetAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1300:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1301:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1301:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1302:1: ( RULE_ID )
            {
             before(grammarAccess.getAcquaintaceAccess().getTargetPersonCrossReference_2_0()); 
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1303:1: ( RULE_ID )
            // ../hu.bme.mit.inf.socialnetwork.language.ui/src-gen/hu/bme/mit/inf/socialnetwork/language/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1304:1: RULE_ID
            {
             before(grammarAccess.getAcquaintaceAccess().getTargetPersonIDTerminalRuleCall_2_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Acquaintace__TargetAssignment_22556); 
             after(grammarAccess.getAcquaintaceAccess().getTargetPersonIDTerminalRuleCall_2_0_1()); 

            }

             after(grammarAccess.getAcquaintaceAccess().getTargetPersonCrossReference_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintace__TargetAssignment_2"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_entryRuleEntity121 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleEntity128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Entity__Alternatives_in_ruleEntity154 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity181 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0_in_ruleCommunity214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson241 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson248 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0_in_rulePerson274 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintace_in_entryRuleAcquaintace301 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAcquaintace308 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__0_in_ruleAcquaintace334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__AcqType__Alternatives_in_ruleAcqType371 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Entity__Alternatives406 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_rule__Entity__Alternatives423 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__AcqType__Alternatives456 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__AcqType__Alternatives477 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_rule__AcqType__Alternatives498 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0531 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0534 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_rule__SocialNetwork__Group__0__Impl562 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1593 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1596 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_rule__SocialNetwork__Group__1__Impl624 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2655 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3716 = new BitSet(new long[]{0x00000000000E0000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__4_in_rule__SocialNetwork__Group__3719 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__SocialNetwork__Group__3__Impl747 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__4__Impl_in_rule__SocialNetwork__Group__4778 = new BitSet(new long[]{0x00000000000E0000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__5_in_rule__SocialNetwork__Group__4781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__EntitiesAssignment_4_in_rule__SocialNetwork__Group__4__Impl808 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__5__Impl_in_rule__SocialNetwork__Group__5839 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__SocialNetwork__Group__5__Impl867 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__0910 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Community__Group__1_in_rule__Community__Group__0913 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_rule__Community__Group__0__Impl941 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__1972 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Community__Group__2_in_rule__Community__Group__1975 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1002 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21032 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1059 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__01096 = new BitSet(new long[]{0x0000000000060000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__01099 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Community__Group_2__0__Impl1127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__11158 = new BitSet(new long[]{0x0000000000060000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__11161 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__SubcommunitiesAssignment_2_1_in_rule__Community__Group_2__1__Impl1188 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__21219 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Community__Group_2__2__Impl1247 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__01284 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group__1_in_rule__Person__Group__01287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_rule__Person__Group__0__Impl1315 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__11346 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Person__Group__2_in_rule__Person__Group__11349 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1376 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21406 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21409 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Person__Group__2__Impl1437 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31468 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31471 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_rule__Person__Group__3__Impl1499 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41530 = new BitSet(new long[]{0x0000000000020010L});
    public static final BitSet FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41533 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Person__Group__4__Impl1561 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51592 = new BitSet(new long[]{0x0000000000020010L});
    public static final BitSet FOLLOW_rule__Person__Group__6_in_rule__Person__Group__51595 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_5__0_in_rule__Person__Group__5__Impl1622 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__6__Impl_in_rule__Person__Group__61653 = new BitSet(new long[]{0x0000000000023800L});
    public static final BitSet FOLLOW_rule__Person__Group__7_in_rule__Person__Group__61656 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Person__Group__6__Impl1684 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__7__Impl_in_rule__Person__Group__71715 = new BitSet(new long[]{0x0000000000023800L});
    public static final BitSet FOLLOW_rule__Person__Group__8_in_rule__Person__Group__71718 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__AcquaintacesAssignment_7_in_rule__Person__Group__7__Impl1745 = new BitSet(new long[]{0x0000000000003802L});
    public static final BitSet FOLLOW_rule__Person__Group__8__Impl_in_rule__Person__Group__81776 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Person__Group__8__Impl1804 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_5__0__Impl_in_rule__Person__Group_5__01853 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_rule__Person__Group_5__1_in_rule__Person__Group_5__01856 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__CommunityAssignment_5_0_in_rule__Person__Group_5__0__Impl1883 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_5__1__Impl_in_rule__Person__Group_5__11913 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_5_1__0_in_rule__Person__Group_5__1__Impl1940 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_rule__Person__Group_5_1__0__Impl_in_rule__Person__Group_5_1__01975 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group_5_1__1_in_rule__Person__Group_5_1__01978 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_rule__Person__Group_5_1__0__Impl2006 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_5_1__1__Impl_in_rule__Person__Group_5_1__12037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__CommunityAssignment_5_1_1_in_rule__Person__Group_5_1__1__Impl2064 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__0__Impl_in_rule__Acquaintace__Group__02098 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__1_in_rule__Acquaintace__Group__02101 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__TypeAssignment_0_in_rule__Acquaintace__Group__0__Impl2128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__1__Impl_in_rule__Acquaintace__Group__12158 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__2_in_rule__Acquaintace__Group__12161 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_rule__Acquaintace__Group__1__Impl2189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__Group__2__Impl_in_rule__Acquaintace__Group__22220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintace__TargetAssignment_2_in_rule__Acquaintace__Group__2__Impl2247 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_rule__SocialNetwork__EntitiesAssignment_42288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12319 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Community__SubcommunitiesAssignment_2_12350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12381 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__CommunityAssignment_5_02416 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__CommunityAssignment_5_1_12455 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintace_in_rule__Person__AcquaintacesAssignment_72490 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcqType_in_rule__Acquaintace__TypeAssignment_02521 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Acquaintace__TargetAssignment_22556 = new BitSet(new long[]{0x0000000000000002L});

}